<template>
  <div :class="['f fdc aic accordion', {'accordion--disabled': !isActive}]">
    <slot />
  </div>
</template>

<script>
import throttle from 'lodash.throttle'
import { on } from '@/assets/js/lib/dom'
import { map } from '@/assets/js/lib/utils'

export default {
  name: 'AccordionView',
  props: {
    watchCss: Boolean,
    isSingle: Boolean
  },
  data () {
    return {
      isActive: true,
      blocks: [],
      accordion: {
        isInit: true
      }
    }
  },
  provide () {
    return {
      registerBlock: this.registerBlock.bind(this),
      accordion: this.accordion
    }
  },
  mounted () {
    if (this.watchCss) {
      this.handleWatchCss()

      let windowWidth = window.innerWidth
      on('resize', throttle(() => {
        if (windowWidth !== window.innerWidth) {
          this.handleWatchCss()
          windowWidth = window.innerWidth
        }
      }, 100), window)
    }
    if (this.isActive && this.isSingle) {
      map(block => {
        block.$on('activate-block', (blockId) => {
          this.activateSingleBlock(blockId)
        })
      }, this.blocks)
    }
  },
  methods: {
    init () {
      this.isActive = true
      map(block => block.deactivate(), this.blocks)
    },
    destroy () {
      this.isActive = false
      map(block => block.activate(), this.blocks)
    },
    registerBlock (block) {
      this.blocks.push(block)
    },
    handleWatchCss () {
      const afterContent = window.getComputedStyle(this.$el, ':after').content
      if (afterContent.includes('accordion')) {
        this.accordion.isInit = true
        this.init()
      } else {
        this.accordion.isInit = false
        this.destroy()
      }
    },
    activateSingleBlock (blockId) {
      map(block => {
        if (block.uuid !== blockId) {
          block.deactivate()
        }
      }, this.blocks)
    }
  }
}
</script>
